# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetCertificatesCertificateResult',
    'GetServiceCertificatesCertificateResult',
]

@pulumi.output_type
class GetCertificatesCertificateResult(dict):
    def __init__(__self__, *,
                 buy_in_aliyun: bool,
                 cert: str,
                 cert_id: str,
                 certificate_name: str,
                 city: str,
                 common: str,
                 country: str,
                 end_date: str,
                 expired: bool,
                 fingerprint: str,
                 id: str,
                 issuer: str,
                 key: str,
                 name: str,
                 org_name: str,
                 province: str,
                 sans: str,
                 start_date: str):
        """
        :param bool buy_in_aliyun: The cert is buy from aliyun or not.
        :param str city: The cert's city.
        :param str common: The cert's common name.
        :param str country: The cert's country.
        :param str end_date: The cert's not valid after time.
        :param bool expired: The cert is expired or not.
        :param str id: The cert's id.
        :param str issuer: The cert's .
        :param str name: The cert's name.
        :param str org_name: The cert's organization.
        :param str province: The cert's province.
        :param str sans: The cert's subject alternative name.
        :param str start_date: The cert's not valid before time.
        """
        pulumi.set(__self__, "buy_in_aliyun", buy_in_aliyun)
        pulumi.set(__self__, "cert", cert)
        pulumi.set(__self__, "cert_id", cert_id)
        pulumi.set(__self__, "certificate_name", certificate_name)
        pulumi.set(__self__, "city", city)
        pulumi.set(__self__, "common", common)
        pulumi.set(__self__, "country", country)
        pulumi.set(__self__, "end_date", end_date)
        pulumi.set(__self__, "expired", expired)
        pulumi.set(__self__, "fingerprint", fingerprint)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "issuer", issuer)
        pulumi.set(__self__, "key", key)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "org_name", org_name)
        pulumi.set(__self__, "province", province)
        pulumi.set(__self__, "sans", sans)
        pulumi.set(__self__, "start_date", start_date)

    @property
    @pulumi.getter(name="buyInAliyun")
    def buy_in_aliyun(self) -> bool:
        """
        The cert is buy from aliyun or not.
        """
        return pulumi.get(self, "buy_in_aliyun")

    @property
    @pulumi.getter
    def cert(self) -> str:
        return pulumi.get(self, "cert")

    @property
    @pulumi.getter(name="certId")
    def cert_id(self) -> str:
        return pulumi.get(self, "cert_id")

    @property
    @pulumi.getter(name="certificateName")
    def certificate_name(self) -> str:
        return pulumi.get(self, "certificate_name")

    @property
    @pulumi.getter
    def city(self) -> str:
        """
        The cert's city.
        """
        return pulumi.get(self, "city")

    @property
    @pulumi.getter
    def common(self) -> str:
        """
        The cert's common name.
        """
        return pulumi.get(self, "common")

    @property
    @pulumi.getter
    def country(self) -> str:
        """
        The cert's country.
        """
        return pulumi.get(self, "country")

    @property
    @pulumi.getter(name="endDate")
    def end_date(self) -> str:
        """
        The cert's not valid after time.
        """
        return pulumi.get(self, "end_date")

    @property
    @pulumi.getter
    def expired(self) -> bool:
        """
        The cert is expired or not.
        """
        return pulumi.get(self, "expired")

    @property
    @pulumi.getter
    def fingerprint(self) -> str:
        return pulumi.get(self, "fingerprint")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The cert's id.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def issuer(self) -> str:
        """
        The cert's .
        """
        return pulumi.get(self, "issuer")

    @property
    @pulumi.getter
    def key(self) -> str:
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    @_utilities.deprecated("""Field `name` has been deprecated from provider version 1.129.0. New field `certificate_name` instead.""")
    def name(self) -> str:
        """
        The cert's name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="orgName")
    def org_name(self) -> str:
        """
        The cert's organization.
        """
        return pulumi.get(self, "org_name")

    @property
    @pulumi.getter
    def province(self) -> str:
        """
        The cert's province.
        """
        return pulumi.get(self, "province")

    @property
    @pulumi.getter
    def sans(self) -> str:
        """
        The cert's subject alternative name.
        """
        return pulumi.get(self, "sans")

    @property
    @pulumi.getter(name="startDate")
    def start_date(self) -> str:
        """
        The cert's not valid before time.
        """
        return pulumi.get(self, "start_date")


@pulumi.output_type
class GetServiceCertificatesCertificateResult(dict):
    def __init__(__self__, *,
                 buy_in_aliyun: bool,
                 cert: str,
                 cert_id: str,
                 certificate_name: str,
                 city: str,
                 common: str,
                 country: str,
                 end_date: str,
                 expired: bool,
                 fingerprint: str,
                 id: str,
                 issuer: str,
                 key: str,
                 name: str,
                 org_name: str,
                 province: str,
                 sans: str,
                 start_date: str):
        """
        :param bool buy_in_aliyun: Whether the certificate was purchased from Aliyun. **Note:** From version 1.232.0, `buy_in_aliyun` takes effect only if `enable_details` is set to `true`.
        :param str cert: The Cert of the certificate. **Note:** `cert` takes effect only if `enable_details` is set to `true`.
        :param str cert_id: The ID of the certificate.
        :param str certificate_name: The name of the certificate.
        :param str city: The city in which the organization is located.
        :param str common: The parent domain name of the certificate.
        :param str country: The code of the country in which the organization is located.
        :param str end_date: The time at which the certificate expires.
        :param bool expired: Whether the certificate has expired.
        :param str fingerprint: The fingerprint of the certificate.
        :param str id: The ID of the Ssl Certificates Service Certificate.
        :param str issuer: The issuer of the certificate.
        :param str key: The Key of the certificate. **Note:** `key` takes effect only if `enable_details` is set to `true`.
        :param str name: (Deprecated since v1.129.0) The name of the certificate. **Note:** Field `name` has been deprecated from provider version 1.129.0. New field `certificate_name` instead.
        :param str org_name: The name of the organization that is associated with the certificate.
        :param str province: The province or autonomous region in which the organization is located.
        :param str sans: All domain names that are bound to the certificate.
        :param str start_date: The time at which the certificate starts to take effect.
        """
        pulumi.set(__self__, "buy_in_aliyun", buy_in_aliyun)
        pulumi.set(__self__, "cert", cert)
        pulumi.set(__self__, "cert_id", cert_id)
        pulumi.set(__self__, "certificate_name", certificate_name)
        pulumi.set(__self__, "city", city)
        pulumi.set(__self__, "common", common)
        pulumi.set(__self__, "country", country)
        pulumi.set(__self__, "end_date", end_date)
        pulumi.set(__self__, "expired", expired)
        pulumi.set(__self__, "fingerprint", fingerprint)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "issuer", issuer)
        pulumi.set(__self__, "key", key)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "org_name", org_name)
        pulumi.set(__self__, "province", province)
        pulumi.set(__self__, "sans", sans)
        pulumi.set(__self__, "start_date", start_date)

    @property
    @pulumi.getter(name="buyInAliyun")
    def buy_in_aliyun(self) -> bool:
        """
        Whether the certificate was purchased from Aliyun. **Note:** From version 1.232.0, `buy_in_aliyun` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "buy_in_aliyun")

    @property
    @pulumi.getter
    def cert(self) -> str:
        """
        The Cert of the certificate. **Note:** `cert` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "cert")

    @property
    @pulumi.getter(name="certId")
    def cert_id(self) -> str:
        """
        The ID of the certificate.
        """
        return pulumi.get(self, "cert_id")

    @property
    @pulumi.getter(name="certificateName")
    def certificate_name(self) -> str:
        """
        The name of the certificate.
        """
        return pulumi.get(self, "certificate_name")

    @property
    @pulumi.getter
    def city(self) -> str:
        """
        The city in which the organization is located.
        """
        return pulumi.get(self, "city")

    @property
    @pulumi.getter
    def common(self) -> str:
        """
        The parent domain name of the certificate.
        """
        return pulumi.get(self, "common")

    @property
    @pulumi.getter
    def country(self) -> str:
        """
        The code of the country in which the organization is located.
        """
        return pulumi.get(self, "country")

    @property
    @pulumi.getter(name="endDate")
    def end_date(self) -> str:
        """
        The time at which the certificate expires.
        """
        return pulumi.get(self, "end_date")

    @property
    @pulumi.getter
    def expired(self) -> bool:
        """
        Whether the certificate has expired.
        """
        return pulumi.get(self, "expired")

    @property
    @pulumi.getter
    def fingerprint(self) -> str:
        """
        The fingerprint of the certificate.
        """
        return pulumi.get(self, "fingerprint")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the Ssl Certificates Service Certificate.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def issuer(self) -> str:
        """
        The issuer of the certificate.
        """
        return pulumi.get(self, "issuer")

    @property
    @pulumi.getter
    def key(self) -> str:
        """
        The Key of the certificate. **Note:** `key` takes effect only if `enable_details` is set to `true`.
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    @_utilities.deprecated("""Field `name` has been deprecated from provider version 1.129.0. New field `certificate_name` instead.""")
    def name(self) -> str:
        """
        (Deprecated since v1.129.0) The name of the certificate. **Note:** Field `name` has been deprecated from provider version 1.129.0. New field `certificate_name` instead.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="orgName")
    def org_name(self) -> str:
        """
        The name of the organization that is associated with the certificate.
        """
        return pulumi.get(self, "org_name")

    @property
    @pulumi.getter
    def province(self) -> str:
        """
        The province or autonomous region in which the organization is located.
        """
        return pulumi.get(self, "province")

    @property
    @pulumi.getter
    def sans(self) -> str:
        """
        All domain names that are bound to the certificate.
        """
        return pulumi.get(self, "sans")

    @property
    @pulumi.getter(name="startDate")
    def start_date(self) -> str:
        """
        The time at which the certificate starts to take effect.
        """
        return pulumi.get(self, "start_date")


