# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = ['CompressionRuleArgs', 'CompressionRule']

@pulumi.input_type
class CompressionRuleArgs:
    def __init__(__self__, *,
                 site_id: pulumi.Input[int],
                 brotli: Optional[pulumi.Input[str]] = None,
                 gzip: Optional[pulumi.Input[str]] = None,
                 rule: Optional[pulumi.Input[str]] = None,
                 rule_enable: Optional[pulumi.Input[str]] = None,
                 rule_name: Optional[pulumi.Input[str]] = None,
                 site_version: Optional[pulumi.Input[int]] = None,
                 zstd: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a CompressionRule resource.
        :param pulumi.Input[int] site_id: The site ID, which can be obtained by calling the ListSites API.
        :param pulumi.Input[str] brotli: Brotli compression. Value range:
        :param pulumi.Input[str] gzip: Gzip compression. Value range:
        :param pulumi.Input[str] rule: Rule Content.
        :param pulumi.Input[str] rule_enable: Rule switch. Value range:
        :param pulumi.Input[str] rule_name: Rule name, you can find out the rule whose rule name is the passed field.
        :param pulumi.Input[int] site_version: The version of the website configurations.
        :param pulumi.Input[str] zstd: Zstd compression. Value range:
        """
        pulumi.set(__self__, "site_id", site_id)
        if brotli is not None:
            pulumi.set(__self__, "brotli", brotli)
        if gzip is not None:
            pulumi.set(__self__, "gzip", gzip)
        if rule is not None:
            pulumi.set(__self__, "rule", rule)
        if rule_enable is not None:
            pulumi.set(__self__, "rule_enable", rule_enable)
        if rule_name is not None:
            pulumi.set(__self__, "rule_name", rule_name)
        if site_version is not None:
            pulumi.set(__self__, "site_version", site_version)
        if zstd is not None:
            pulumi.set(__self__, "zstd", zstd)

    @property
    @pulumi.getter(name="siteId")
    def site_id(self) -> pulumi.Input[int]:
        """
        The site ID, which can be obtained by calling the ListSites API.
        """
        return pulumi.get(self, "site_id")

    @site_id.setter
    def site_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "site_id", value)

    @property
    @pulumi.getter
    def brotli(self) -> Optional[pulumi.Input[str]]:
        """
        Brotli compression. Value range:
        """
        return pulumi.get(self, "brotli")

    @brotli.setter
    def brotli(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "brotli", value)

    @property
    @pulumi.getter
    def gzip(self) -> Optional[pulumi.Input[str]]:
        """
        Gzip compression. Value range:
        """
        return pulumi.get(self, "gzip")

    @gzip.setter
    def gzip(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "gzip", value)

    @property
    @pulumi.getter
    def rule(self) -> Optional[pulumi.Input[str]]:
        """
        Rule Content.
        """
        return pulumi.get(self, "rule")

    @rule.setter
    def rule(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rule", value)

    @property
    @pulumi.getter(name="ruleEnable")
    def rule_enable(self) -> Optional[pulumi.Input[str]]:
        """
        Rule switch. Value range:
        """
        return pulumi.get(self, "rule_enable")

    @rule_enable.setter
    def rule_enable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rule_enable", value)

    @property
    @pulumi.getter(name="ruleName")
    def rule_name(self) -> Optional[pulumi.Input[str]]:
        """
        Rule name, you can find out the rule whose rule name is the passed field.
        """
        return pulumi.get(self, "rule_name")

    @rule_name.setter
    def rule_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rule_name", value)

    @property
    @pulumi.getter(name="siteVersion")
    def site_version(self) -> Optional[pulumi.Input[int]]:
        """
        The version of the website configurations.
        """
        return pulumi.get(self, "site_version")

    @site_version.setter
    def site_version(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "site_version", value)

    @property
    @pulumi.getter
    def zstd(self) -> Optional[pulumi.Input[str]]:
        """
        Zstd compression. Value range:
        """
        return pulumi.get(self, "zstd")

    @zstd.setter
    def zstd(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "zstd", value)


@pulumi.input_type
class _CompressionRuleState:
    def __init__(__self__, *,
                 brotli: Optional[pulumi.Input[str]] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 gzip: Optional[pulumi.Input[str]] = None,
                 rule: Optional[pulumi.Input[str]] = None,
                 rule_enable: Optional[pulumi.Input[str]] = None,
                 rule_name: Optional[pulumi.Input[str]] = None,
                 site_id: Optional[pulumi.Input[int]] = None,
                 site_version: Optional[pulumi.Input[int]] = None,
                 zstd: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering CompressionRule resources.
        :param pulumi.Input[str] brotli: Brotli compression. Value range:
        :param pulumi.Input[int] config_id: Config Id
        :param pulumi.Input[str] gzip: Gzip compression. Value range:
        :param pulumi.Input[str] rule: Rule Content.
        :param pulumi.Input[str] rule_enable: Rule switch. Value range:
        :param pulumi.Input[str] rule_name: Rule name, you can find out the rule whose rule name is the passed field.
        :param pulumi.Input[int] site_id: The site ID, which can be obtained by calling the ListSites API.
        :param pulumi.Input[int] site_version: The version of the website configurations.
        :param pulumi.Input[str] zstd: Zstd compression. Value range:
        """
        if brotli is not None:
            pulumi.set(__self__, "brotli", brotli)
        if config_id is not None:
            pulumi.set(__self__, "config_id", config_id)
        if gzip is not None:
            pulumi.set(__self__, "gzip", gzip)
        if rule is not None:
            pulumi.set(__self__, "rule", rule)
        if rule_enable is not None:
            pulumi.set(__self__, "rule_enable", rule_enable)
        if rule_name is not None:
            pulumi.set(__self__, "rule_name", rule_name)
        if site_id is not None:
            pulumi.set(__self__, "site_id", site_id)
        if site_version is not None:
            pulumi.set(__self__, "site_version", site_version)
        if zstd is not None:
            pulumi.set(__self__, "zstd", zstd)

    @property
    @pulumi.getter
    def brotli(self) -> Optional[pulumi.Input[str]]:
        """
        Brotli compression. Value range:
        """
        return pulumi.get(self, "brotli")

    @brotli.setter
    def brotli(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "brotli", value)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> Optional[pulumi.Input[int]]:
        """
        Config Id
        """
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter
    def gzip(self) -> Optional[pulumi.Input[str]]:
        """
        Gzip compression. Value range:
        """
        return pulumi.get(self, "gzip")

    @gzip.setter
    def gzip(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "gzip", value)

    @property
    @pulumi.getter
    def rule(self) -> Optional[pulumi.Input[str]]:
        """
        Rule Content.
        """
        return pulumi.get(self, "rule")

    @rule.setter
    def rule(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rule", value)

    @property
    @pulumi.getter(name="ruleEnable")
    def rule_enable(self) -> Optional[pulumi.Input[str]]:
        """
        Rule switch. Value range:
        """
        return pulumi.get(self, "rule_enable")

    @rule_enable.setter
    def rule_enable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rule_enable", value)

    @property
    @pulumi.getter(name="ruleName")
    def rule_name(self) -> Optional[pulumi.Input[str]]:
        """
        Rule name, you can find out the rule whose rule name is the passed field.
        """
        return pulumi.get(self, "rule_name")

    @rule_name.setter
    def rule_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rule_name", value)

    @property
    @pulumi.getter(name="siteId")
    def site_id(self) -> Optional[pulumi.Input[int]]:
        """
        The site ID, which can be obtained by calling the ListSites API.
        """
        return pulumi.get(self, "site_id")

    @site_id.setter
    def site_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "site_id", value)

    @property
    @pulumi.getter(name="siteVersion")
    def site_version(self) -> Optional[pulumi.Input[int]]:
        """
        The version of the website configurations.
        """
        return pulumi.get(self, "site_version")

    @site_version.setter
    def site_version(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "site_version", value)

    @property
    @pulumi.getter
    def zstd(self) -> Optional[pulumi.Input[str]]:
        """
        Zstd compression. Value range:
        """
        return pulumi.get(self, "zstd")

    @zstd.setter
    def zstd(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "zstd", value)


class CompressionRule(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 brotli: Optional[pulumi.Input[str]] = None,
                 gzip: Optional[pulumi.Input[str]] = None,
                 rule: Optional[pulumi.Input[str]] = None,
                 rule_enable: Optional[pulumi.Input[str]] = None,
                 rule_name: Optional[pulumi.Input[str]] = None,
                 site_id: Optional[pulumi.Input[int]] = None,
                 site_version: Optional[pulumi.Input[int]] = None,
                 zstd: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a ESA Compression Rule resource.

        For information about ESA Compression Rule and how to use it, see [What is Compression Rule](https://next.api.alibabacloud.com/document/ESA/2024-09-10/CreateCompressionRule).

        > **NOTE:** Available since v1.244.0.

        ## Example Usage

        Basic Usage

        ```python
        import pulumi
        import pulumi_alicloud as alicloud

        default = alicloud.esa.get_sites(plan_subscribe_type="enterpriseplan")
        example = alicloud.esa.Site("example",
            site_name="compression.example.com",
            instance_id=default.sites[0].instance_id,
            coverage="domestic",
            access_type="NS")
        default_compression_rule = alicloud.esa.CompressionRule("default",
            gzip="off",
            brotli="off",
            rule="http.host eq \\"video.example.com\\"",
            site_version=0,
            rule_name="rule_example",
            site_id=example.id,
            zstd="off",
            rule_enable="off")
        ```

        ## Import

        ESA Compression Rule can be imported using the id, e.g.

        ```sh
        $ pulumi import alicloud:esa/compressionRule:CompressionRule example <site_id>:<config_id>
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] brotli: Brotli compression. Value range:
        :param pulumi.Input[str] gzip: Gzip compression. Value range:
        :param pulumi.Input[str] rule: Rule Content.
        :param pulumi.Input[str] rule_enable: Rule switch. Value range:
        :param pulumi.Input[str] rule_name: Rule name, you can find out the rule whose rule name is the passed field.
        :param pulumi.Input[int] site_id: The site ID, which can be obtained by calling the ListSites API.
        :param pulumi.Input[int] site_version: The version of the website configurations.
        :param pulumi.Input[str] zstd: Zstd compression. Value range:
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CompressionRuleArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a ESA Compression Rule resource.

        For information about ESA Compression Rule and how to use it, see [What is Compression Rule](https://next.api.alibabacloud.com/document/ESA/2024-09-10/CreateCompressionRule).

        > **NOTE:** Available since v1.244.0.

        ## Example Usage

        Basic Usage

        ```python
        import pulumi
        import pulumi_alicloud as alicloud

        default = alicloud.esa.get_sites(plan_subscribe_type="enterpriseplan")
        example = alicloud.esa.Site("example",
            site_name="compression.example.com",
            instance_id=default.sites[0].instance_id,
            coverage="domestic",
            access_type="NS")
        default_compression_rule = alicloud.esa.CompressionRule("default",
            gzip="off",
            brotli="off",
            rule="http.host eq \\"video.example.com\\"",
            site_version=0,
            rule_name="rule_example",
            site_id=example.id,
            zstd="off",
            rule_enable="off")
        ```

        ## Import

        ESA Compression Rule can be imported using the id, e.g.

        ```sh
        $ pulumi import alicloud:esa/compressionRule:CompressionRule example <site_id>:<config_id>
        ```

        :param str resource_name: The name of the resource.
        :param CompressionRuleArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CompressionRuleArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 brotli: Optional[pulumi.Input[str]] = None,
                 gzip: Optional[pulumi.Input[str]] = None,
                 rule: Optional[pulumi.Input[str]] = None,
                 rule_enable: Optional[pulumi.Input[str]] = None,
                 rule_name: Optional[pulumi.Input[str]] = None,
                 site_id: Optional[pulumi.Input[int]] = None,
                 site_version: Optional[pulumi.Input[int]] = None,
                 zstd: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CompressionRuleArgs.__new__(CompressionRuleArgs)

            __props__.__dict__["brotli"] = brotli
            __props__.__dict__["gzip"] = gzip
            __props__.__dict__["rule"] = rule
            __props__.__dict__["rule_enable"] = rule_enable
            __props__.__dict__["rule_name"] = rule_name
            if site_id is None and not opts.urn:
                raise TypeError("Missing required property 'site_id'")
            __props__.__dict__["site_id"] = site_id
            __props__.__dict__["site_version"] = site_version
            __props__.__dict__["zstd"] = zstd
            __props__.__dict__["config_id"] = None
        super(CompressionRule, __self__).__init__(
            'alicloud:esa/compressionRule:CompressionRule',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            brotli: Optional[pulumi.Input[str]] = None,
            config_id: Optional[pulumi.Input[int]] = None,
            gzip: Optional[pulumi.Input[str]] = None,
            rule: Optional[pulumi.Input[str]] = None,
            rule_enable: Optional[pulumi.Input[str]] = None,
            rule_name: Optional[pulumi.Input[str]] = None,
            site_id: Optional[pulumi.Input[int]] = None,
            site_version: Optional[pulumi.Input[int]] = None,
            zstd: Optional[pulumi.Input[str]] = None) -> 'CompressionRule':
        """
        Get an existing CompressionRule resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] brotli: Brotli compression. Value range:
        :param pulumi.Input[int] config_id: Config Id
        :param pulumi.Input[str] gzip: Gzip compression. Value range:
        :param pulumi.Input[str] rule: Rule Content.
        :param pulumi.Input[str] rule_enable: Rule switch. Value range:
        :param pulumi.Input[str] rule_name: Rule name, you can find out the rule whose rule name is the passed field.
        :param pulumi.Input[int] site_id: The site ID, which can be obtained by calling the ListSites API.
        :param pulumi.Input[int] site_version: The version of the website configurations.
        :param pulumi.Input[str] zstd: Zstd compression. Value range:
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _CompressionRuleState.__new__(_CompressionRuleState)

        __props__.__dict__["brotli"] = brotli
        __props__.__dict__["config_id"] = config_id
        __props__.__dict__["gzip"] = gzip
        __props__.__dict__["rule"] = rule
        __props__.__dict__["rule_enable"] = rule_enable
        __props__.__dict__["rule_name"] = rule_name
        __props__.__dict__["site_id"] = site_id
        __props__.__dict__["site_version"] = site_version
        __props__.__dict__["zstd"] = zstd
        return CompressionRule(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def brotli(self) -> pulumi.Output[Optional[str]]:
        """
        Brotli compression. Value range:
        """
        return pulumi.get(self, "brotli")

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Output[int]:
        """
        Config Id
        """
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter
    def gzip(self) -> pulumi.Output[Optional[str]]:
        """
        Gzip compression. Value range:
        """
        return pulumi.get(self, "gzip")

    @property
    @pulumi.getter
    def rule(self) -> pulumi.Output[Optional[str]]:
        """
        Rule Content.
        """
        return pulumi.get(self, "rule")

    @property
    @pulumi.getter(name="ruleEnable")
    def rule_enable(self) -> pulumi.Output[Optional[str]]:
        """
        Rule switch. Value range:
        """
        return pulumi.get(self, "rule_enable")

    @property
    @pulumi.getter(name="ruleName")
    def rule_name(self) -> pulumi.Output[Optional[str]]:
        """
        Rule name, you can find out the rule whose rule name is the passed field.
        """
        return pulumi.get(self, "rule_name")

    @property
    @pulumi.getter(name="siteId")
    def site_id(self) -> pulumi.Output[int]:
        """
        The site ID, which can be obtained by calling the ListSites API.
        """
        return pulumi.get(self, "site_id")

    @property
    @pulumi.getter(name="siteVersion")
    def site_version(self) -> pulumi.Output[Optional[int]]:
        """
        The version of the website configurations.
        """
        return pulumi.get(self, "site_version")

    @property
    @pulumi.getter
    def zstd(self) -> pulumi.Output[Optional[str]]:
        """
        Zstd compression. Value range:
        """
        return pulumi.get(self, "zstd")

